<?xml version="1.0" encoding="UTF-8"?>
<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema"
           targetNamespace="http://www.epam.com/chat"
           xmlns:chat="http://www.epam.com/chat"
           elementFormDefault="qualified">

    <xs:element name="online_chat">
        <xs:complexType>
            <xs:all>
                <xs:element name="roles" type="chat:roles" />
                <xs:element name="statuses" type="chat:statuses" />
                <xs:element name="users" type="chat:users" />
                <xs:element name="messages" type="chat:messages" />
            </xs:all>
        </xs:complexType>

        <xs:key name="PKUser">
            <xs:selector xpath="chat:users/chat:user"/>
            <xs:field xpath="chat:login"/>
        </xs:key>

        <xs:key name="PKRole">
            <xs:selector xpath="chat:roles/chat:role"/>
            <xs:field xpath="chat:role_name"/>
        </xs:key>

        <xs:keyref name="FKUserToRole" refer="chat:PKRole">
            <xs:selector xpath="chat:users/chat:user"/>
            <xs:field xpath="chat:role_user"/>
        </xs:keyref>

        <xs:key name="PKStatus">
            <xs:selector xpath="chat:statuses/chat:status"/>
            <xs:field xpath="chat:status_name"/>
        </xs:key>

        <xs:key name="PKMessage">
            <xs:selector xpath="chat:messages/chat:message"/>
            <xs:field xpath="chat:user_from"/>
            <xs:field xpath="chat:time_stamp"/>
        </xs:key>

        <xs:keyref name="FKMessageToStatus" refer="chat:PKStatus">
            <xs:selector xpath="chat:messages/chat:message"/>
            <xs:field xpath="chat:message_status"/>
        </xs:keyref>

        <xs:keyref name="FKMessageToUser" refer="chat:PKUser">
            <xs:selector xpath="chat:messages/chat:message"/>
            <xs:field xpath="chat:user_from"/>
        </xs:keyref>
    </xs:element>

    <xs:simpleType name="upper-case">
        <xs:restriction base="xs:normalizedString">
            <xs:pattern value="[A-Z]+"/>
        </xs:restriction>
    </xs:simpleType>

    <!-- create schema for role -->
    <xs:complexType name="roles">
        <xs:sequence>
            <xs:element name="role" maxOccurs="2" type="chat:role" />
        </xs:sequence>
    </xs:complexType>

    <xs:complexType name="role">
        <xs:sequence>
            <xs:element name="role_name" type="chat:upper-case"/>
            <xs:element name="role_description" type="xs:string"/>
        </xs:sequence>
    </xs:complexType>

    <!-- create schema for statuses -->
    <xs:complexType name="statuses">
        <xs:sequence>
            <xs:element name="status" maxOccurs="5" type="chat:status" />
        </xs:sequence>
    </xs:complexType>

    <xs:complexType name="status">
        <xs:sequence>
            <xs:element name="status_name" type="chat:upper-case"/>
            <xs:element name="status_description" type="xs:string"/>
        </xs:sequence>
    </xs:complexType>


    <!-- create schema for user -->

    <xs:simpleType name="log">
        <xs:restriction base="xs:ID">
            <xs:pattern value="[a-zA-Z][a-zA-Z0-9_]*"/>
        </xs:restriction>
    </xs:simpleType>

    <xs:complexType name="users">
        <xs:sequence>
            <xs:element name="user" maxOccurs="unbounded" type="chat:user" />
        </xs:sequence>
    </xs:complexType>

    <xs:complexType name="user">
        <xs:sequence>
            <xs:element name="login" type="chat:log"/>
            <xs:element name="role_user" type="chat:upper-case"/>
        </xs:sequence>
    </xs:complexType>

    <!-- create schema for message -->

    <xs:simpleType name="log_for_message">
        <xs:restriction base="xs:string">
            <xs:pattern value="[a-zA-Z][a-zA-Z0-9_]*"/>
        </xs:restriction>
    </xs:simpleType>


    <xs:complexType name="messages">
        <xs:sequence>
            <xs:element name="message" maxOccurs="unbounded" type="chat:message" />
        </xs:sequence>
    </xs:complexType>

    <xs:complexType name="message">
        <xs:sequence>
            <xs:element name="user_from" type="chat:log_for_message"/>
            <xs:element name="time_stamp" type="xs:dateTime"/>
            <xs:element name="text" type="xs:string"/>
            <xs:element name="message_status" type="chat:upper-case"/>
        </xs:sequence>
    </xs:complexType>

</xs:schema>